from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Boolean, File, String, Int

Ssu_Esl_Reformat_V0_1_0 = CommandToolBuilder(tool="ssu_esl_reformat", base_command=["ssu-esl-reformat"], inputs=[ToolInput(tag="in_convert_dna_ut", input_type=Boolean(optional=True), prefix="-d", doc=InputDocumentation(doc=": convert to DNA alphabet (U->T)")), ToolInput(tag="in_convert_lower_case", input_type=Boolean(optional=True), prefix="-l", doc=InputDocumentation(doc=": convert to lower case")), ToolInput(tag="in_remove_iupac_codes", input_type=Boolean(optional=True), prefix="-n", doc=InputDocumentation(doc=": remove DNA IUPAC codes; convert ambig chars to N")), ToolInput(tag="in_send_output_file", input_type=File(optional=True), prefix="-o", doc=InputDocumentation(doc=": send output to file <f>, not stdout")), ToolInput(tag="in_convert_rna_alphabet", input_type=Boolean(optional=True), prefix="-r", doc=InputDocumentation(doc=": convert to RNA alphabet (T->U)")), ToolInput(tag="in_convert_upper_case", input_type=Boolean(optional=True), prefix="-u", doc=InputDocumentation(doc=": convert to upper case")), ToolInput(tag="in_convert_noniupac_chars", input_type=Boolean(optional=True), prefix="-x", doc=InputDocumentation(doc=": convert non-IUPAC chars (e.g. X) in DNA to N")), ToolInput(tag="in_gap_sym", input_type=String(optional=True), prefix="--gapsym", doc=InputDocumentation(doc=": convert all gaps to character <c>")), ToolInput(tag="in_in_format", input_type=File(optional=True), prefix="--informat", doc=InputDocumentation(doc=": input sequence file is in format <s>")), ToolInput(tag="in_min_gap", input_type=Boolean(optional=True), prefix="--mingap", doc=InputDocumentation(doc=": remove columns containing all gaps (seqfile=MSA)")), ToolInput(tag="in_keep_rf", input_type=Boolean(optional=True), prefix="--keeprf", doc=InputDocumentation(doc=": with --mingap, keep all nongap #=GC RF columns")), ToolInput(tag="in_no_gap", input_type=Boolean(optional=True), prefix="--nogap", doc=InputDocumentation(doc=": remove columns containing any gaps (seqfile=MSA)")), ToolInput(tag="in_w_us_sify", input_type=Boolean(optional=True), prefix="--wussify", doc=InputDocumentation(doc=": convert old RNA structure markup lines to WUSS")), ToolInput(tag="in_de_wuss", input_type=Boolean(optional=True), prefix="--dewuss", doc=InputDocumentation(doc=": convert WUSS RNA structure markup to old format")), ToolInput(tag="in_full_wuss", input_type=Boolean(optional=True), prefix="--fullwuss", doc=InputDocumentation(doc=": convert simple WUSS notation to full (output) WUSS")), ToolInput(tag="in_ignore", input_type=String(optional=True), prefix="--ignore", doc=InputDocumentation(doc=": ignore input seq characters listed in string <s>")), ToolInput(tag="in_accept_x", input_type=String(optional=True), prefix="--acceptx", doc=InputDocumentation(doc=": accept input seq chars in string <s> as X")), ToolInput(tag="in_rename", input_type=Int(optional=True), prefix="--rename", doc=InputDocumentation(doc=": rename and number each sequence <s>.<n>")), ToolInput(tag="in_small", input_type=Boolean(optional=True), prefix="--small", doc=InputDocumentation(doc=": use minimal RAM, input must be pfam, ouput must be afa or pfam")), ToolInput(tag="in_options", input_type=Boolean(optional=True), prefix="-options", doc=InputDocumentation(doc="")), ToolInput(tag="in_fast_a", input_type=String(), position=0, doc=InputDocumentation(doc="stockholm")), ToolInput(tag="in_pfam", input_type=String(), position=1, doc=InputDocumentation(doc="a2m")), ToolInput(tag="in_psiblast", input_type=String(), position=2, doc=InputDocumentation(doc="afa"))], outputs=[ToolOutput(tag="out_send_output_file", output_type=File(optional=True), selector=InputSelector(input_to_select="in_send_output_file", type_hint=File()), doc=OutputDocumentation(doc=": send output to file <f>, not stdout"))], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Ssu_Esl_Reformat_V0_1_0().translate("wdl", allow_empty_container=True)

